import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;

/**
 * Write a description of class Cart here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Cart extends Actor
{
    public int Wheel = 2;
    public int Block = 3;
    int[][] grid;
    Point touch;
    int x = 0;
    int y = 0;
    double vx = 0;
    double vy = 0;
    double vr = 0;
    boolean playing = false;
    float rot = 0;
    Wheel wheelPoint;
    public Cart(int[][] what)
    {
        GreenfootImage g = new GreenfootImage(140,140);
        g.setColor(Color.red);
        grid = what;
        getXC();
        getYC();
        for(int i=0;i<7;i++)
        for(int j=0;j<7;j++)
            if(grid[i][j] == 3) g.drawRect(i*20 + (70 - x),j*20 + (70 - y),20,20); else if(grid[i][j] == 2) g.drawOval(i*20 + (70 - x),j*20 + (70 - y),20,20);
        g.setColor(Color.green);
        g.drawRect(70,70,1,1);
        setImage(g);
    }
    public void getXC()
    {
        int leftV = 0;
        int rightV = 0;
        int left = 0;
        int right = 0;
        for(int j=0;j<140;j++)
        {
            if(left<=right){
                leftV++;
                for(int i=0;i<7;i++) if(grid[6-(leftV/20)][i] == Wheel || grid[6-(leftV/20)][i] == Block) left++;
            }
            else
            {
                rightV++;
                for(int i=0;i<7;i++) if(grid[rightV/20][i] == Wheel || grid[rightV/20][i] == Block) right++;
            }
        }
        x = rightV;
    }
    public void getYC()
    {
        int leftV = 0;
        int rightV = 0;
        int left = 0;
        int right = 0;
        for(int j=0;j<140;j++)
        {
            if(left<=right){
                leftV++;
                for(int i=0;i<7;i++) if(grid[i][6-(leftV/20)] == Wheel || grid[i][6-(leftV/20)] == Block) left++;
            }
            else
            {
                rightV++;
                for(int i=0;i<7;i++) if(grid[i][rightV/20] == Wheel || grid[i][rightV/20] == Block) right++;
            }
        }
        y = rightV;
    }
    public void physic()
    {
        vy+=.1;
        setRotation(getRotation()+(int)Math.round(vr));
        if(touch != null){
            double mag = Math.hypot(touch.x,touch.y)/3;
            vx += -touch.x/20;
        }
        setLocation(getX()+(int)vx,getY()+(int)vy);
        List<Point> points = getConnections();
        if(points.size()>0){
            vy = 0;
            if(points.size()==1) rotateAround(points.get(0));
            else
            {
                boolean left = false;
                boolean right = false;
                int closest = 0;
                int value = 1000;
                for(int i=0;i<points.size();i++)
                {
                    if(points.get(i).x<value)
                    {
                        closest = i;
                        value = points.get(i).x;
                    }
                    if(points.get(i).x>0) right = true;
                    else left = true;
                }
                if(left && right){}
                    //((world)getWorld()).set(0);
                else rotateAround(points.get(closest));
            }
            while(getConnections().size()>0) setLocation(getX(),getY()-1);
        }
        else
        {
            List<Wheel> wheels = checkWheels();
            if(wheels.size()==1)
            {
                int direction = 1;
                if(wheels.get(0).x>0) direction = -1;
                //while((checkWheels().size() ==1)) turn(direction);
                vr = direction*vy;
                wheelPoint = wheels.get(0);
            }
            if(wheels.size()>1){
                vr = 0;
                vy = -.5*vy;
                vx += (wheels.get(0).x-wheels.get(1).x)*(wheels.get(0).y-wheels.get(1).y)/Math.pow(
                    Math.hypot((wheels.get(0).x-wheels.get(1).x),(wheels.get(0).y-wheels.get(1).y)),2
                    );
            }
            touch = null;
        }
    }
    public void rotateAround(Point point)
    {
            vr += -point.x/27;
            double gockX = vx;
            double gockY = vy;
            vx = -point.x/10;
            vy = -.3*vy;
    }
    public List<Point> getConnections()
    {
        List<Point> points = new ArrayList<Point>();
        for(int i = 0;i < 7;i++)
        for(int j = 0;j < 7;j++)
        {
            if(grid[i][j] == Block)
            {
                double rot1 = -Math.toRadians(getRotation())+Math.atan2(j*20-y,i*20-x);
                double rot2 = -Math.toRadians(getRotation())+Math.atan2(j*20-y,i*20-x+20);
                double rot3 = -Math.toRadians(getRotation())+Math.atan2(j*20-y+20,i*20-x);
                double rot4 = -Math.toRadians(getRotation())+Math.atan2(j*20-y+20,i*20-x+20);
                while(rot1<0) rot1 += 2*Math.PI;
                while(rot2<0) rot2 += 2*Math.PI;
                while(rot3<0) rot3 += 2*Math.PI;
                while(rot4<0) rot4 += 2*Math.PI;
                if(
                    getWorld().getBackground().getColorAt(getX()+(int)(Math.cos(rot1)*Math.hypot(i*20 - x,j*20 - y)),
                    getY()+(int)(Math.sin(rot1)*Math.hypot(i*20 - x,j*20 - y))).getRed()<100
                )
                { 
                    points.add(new Point((int)(Math.cos(rot1)*Math.hypot(i*20 - x,j*20 - y)),(int)(Math.sin(rot1)*Math.hypot(i*20 - x,j*20 - y))));
                }
                if(
                    getWorld().getBackground().getColorAt(getX()+(int)(Math.cos(rot2)*Math.hypot(i*20 - x+20,j*20 - y)),
                    getY()+(int)(Math.sin(rot2)*Math.hypot(i*20 - x+20,j*20 - y))).getRed()<100
                ) 
                { 
                    points.add(new Point((int)(Math.cos(rot2)*Math.hypot(i*20-x+20,j*20-y)),(int)(Math.sin(rot2)*Math.hypot(i*20-x+20,j*20-y))));
                    
                }
                if(
                    getWorld().getBackground().getColorAt(getX()+(int)(Math.cos(rot3)*Math.hypot(i*20 - x,j*20 - y+20)),
                    getY()+(int)(Math.sin(rot3)*Math.hypot(i*20 - x,j*20 - y+20))).getRed()<100
                ) 
                { 
                    points.add(new Point((int)(Math.cos(rot3)*Math.hypot(i*20 -x,j*20-y+20)),(int)(Math.sin(rot3)*Math.hypot(i*20 - x,j*20-y+20))));
                    
                }
                if(
                    getWorld().getBackground().getColorAt(getX()+(int)(Math.cos(rot4)*Math.hypot(i*20 - x+20,j*20 - y+20)),
                    getY()+(int)(Math.sin(rot4)*Math.hypot(i*20 - x+20,j*20 - y+20))).getRed()<100
                )
                { 
                    points.add(new Point((int)(Math.cos(rot4)*Math.hypot(i*20-x+20,j*20-y+20)),(int)(Math.sin(rot4)*Math.hypot(i*20-x+20,j*20-y+20))));
                    
                }
            }
        }
        return points;
    }
    public List<Wheel> checkWheels()
    {
        List<Wheel> wheels = new ArrayList<Wheel>();
        for(int i = 0;i < 7;i++)
        for(int j = 0;j < 7;j++)
            if(grid[i][j] == Wheel)
            {
                double baseX = i*20 - x+10;
                double baseY = j*20 - y+10;
                double mag = Math.hypot(baseX,baseY);
                double rot = Math.atan2(baseY,baseX)-Math.toRadians(getRotation());
                baseX = mag*Math.cos(rot);
                baseY = mag*Math.sin(rot);
                int num = 0;
                int rep = 0;
                for(int k = 0;k<360;k++)
                {
                    double angle = (Math.PI-rot)+Math.toRadians(k);
                    if(getWorld().getBackground().getColorAt(getX()+(int)(baseX+Math.cos(angle)*13),getY()+(int)(baseY+Math.sin(angle)*13)).getRed()<100)
                    {
                        num+=k;
                        rep++;
                    }
                }
                if(rep>0)
                {
                    wheels.add(new Wheel((int)baseX,(int)baseY, num/rep));
                }
            }
        return wheels;
    }
    /**
     * Act - do whatever the Cart wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(Greenfoot.isKeyDown("space")) playing = true;
        if(playing)
            physic();
        
    }    
    public class Point
    {
        int x,y;
        public Point(int x2, int y2)
        {
            x = x2;
            y = y2;
        }
    }
    public class Wheel
    {
        int x,y, rotation;
        public Wheel(int x2, int y2, int rotation2)
        {
            x = x2;
            y = y2;
            rotation = rotation2;
        }
    }
}
